package ksu.cis.collaboration;

/**
 * This type was created in VisualAge.
 */
import java.net.*;
import java.io.*;
import ksu.cis.mom.*;
import ksu.cis.collaboration.gui.*;

public class Client_Request_Info_Source extends Conversation
{
	ClientAgent parent; // override parent
	String infoType;
/**
 * Server_Register constructor comment.
 */
public Client_Request_Info_Source(ClientAgent a, String hostName, 
	int portNum, String theService)
{
	super(a, hostName, portNum);
	parent = a;
	infoType = theService;
}
/**
 * This method was created in VisualAge.
 */
public void run() {
	Thread init;
	Message m = new Message();
	int state = 0;
	boolean notDone = true;
	parent.write("Starting Client_Request_Info_Source conversation.");

	//set up conversation
	try {
		connection = new Socket(connectionHost, connectionPort);
		output = new ObjectOutputStream(connection.getOutputStream());
		output.flush();
		input = new ObjectInputStream(connection.getInputStream());
		while (notDone) {
			switch (state) {
				case 0 :
					parent.write("   Requesting agent with info on " + infoType);
					m.performative = "request_source";
					m.content = infoType;
					sendMessage(m, output);
					state = 1;
					break;
				case 1 :
					m = readMessage(input);
					if (m == null)
						parent.write(" ** No message returned from Server!!!");
					else
						if (m.performative.equals("send")) {
							/* convert from Source to InfoType_Source & save the source in GUI list2 */
							InfoType_Source is = new InfoType_Source(infoType, ((Source) (m.content)).host, ((Source) (m.content)).port);
							parent.saveInfoSource(is);
							notDone = false;
						} else
							parent.write("** ERROR - did not get reply back **");
					break;
			}
		}
		parent.write("Ending Client_Request_Info_Source conversation.");
		input.close();
		output.close();
		connection.close();
	} catch (UnknownHostException e) {
		parent.write("** Unknown Host exception in Client_Register.");
	} catch (EOFException oef) {
		parent.write("** Server terminated connection in Client_Register.");
	} catch (IOException e) {
		parent.write("** IO Exception in Client_Register.");
		e.printStackTrace();
	}
}
}
