package ksu.cis.collaboration;

/**
 * This type was created in VisualAge.
 */
import java.net.*;
import java.io.*;
import ksu.cis.mom.*;
public class Requestor_Request_Info extends Conversation
{
	ClientAgent parent; // override parent
	String infoType;
/**
 * Server_Register constructor comment.
 */
public Requestor_Request_Info(ClientAgent a, String hostName, 
	int portNum, String iType)
{
	super(a, hostName, portNum);
	parent = a;
	infoType = iType;
}
/**
 * This method was created in VisualAge.
 */
public void run() {
	Message m = new Message();
	int state = 0;
	boolean notDone = true;
	parent.write("Starting Requestor_Request_Info conversation.");

	//set up conversation
	try {
		connection = new Socket(connectionHost, connectionPort);
		output = new ObjectOutputStream(connection.getOutputStream());
		output.flush();
		input = new ObjectInputStream(connection.getInputStream());
		while (notDone) {
			switch (state) {
				case 0 :
					parent.write("   Requesting info on " + infoType);
					m.performative = "request";
					m.content = infoType;
					sendMessage(m, output);
					state = 1;
					break;
				case 1 :
					m = readMessage(input);
					if (m == null)
						parent.write(" ** No message returned from Server!!!");
					else
						if (m.performative.equals("send")) {
							/* only temporary until we determine what to do with returned values */
							parent.save_info(infoType, (String) m.content);
							parent.write("   Returned info: " + (String) m.content);
							notDone = false;
						} else
							parent.write("** ERROR - did not get reply back **");
					break;
			}
		}
		parent.write("Ending Requestor_Request_Info conversation.");
		input.close();
		output.close();
		connection.close();
	} catch (UnknownHostException e) {
		parent.write("** Unknown Host exception in Client_Register.");
	} catch (EOFException oef) {
		parent.write("** Server terminated connection in Client_Register.");
	} catch (IOException e) {
		parent.write("** IO Exception in Client_Register.");
		e.printStackTrace();
	}
}
}
