package ksu.cis.collaboration;

/**
 * This type was created in VisualAge.
 */
import java.net.*;
import java.io.*;
import ksu.cis.mom.*;
public class Server_Return_Info_Source extends Conversation
{
	ServerAgent parent; // override parent
	InfoType_Source data;
/**
 * Server_Register constructor comment.
 */
public Server_Return_Info_Source(ServerAgent a, String hostName, int portNum, String theHost, int thePort, String theInfo)
{
	super(a, hostName, portNum);
	parent = a;
	data = new InfoType_Source(theInfo, theHost, thePort);
}
/**
 * This method was created in VisualAge.
 */
public void run() {
	Message m = new Message();
	int state = 0;
	boolean notDone = true;
	parent.write("Starting Server_Return_Info_Source conversation to ");

	//set up conversation
	try {
		connection = new Socket(connectionHost, connectionPort);
		output = new ObjectOutputStream(connection.getOutputStream());
		output.flush();
		input = new ObjectInputStream(connection.getInputStream());
		while (notDone) {
			switch (state) {
				case 0 :
					m.performative = "send";
					m.content = data;
					sendMessage(m, output);
					state = 1;
					break;
				case 1 :
					m = readMessage(input);
					if (m.performative.equals("acknowledge"))
						notDone = false;
					else
						parent.write("** ERROR - did not get reply back **");
					break;
			}
		}
		parent.write("Ending Server_Return_Info_Source conversation.");
		input.close();
		output.close();
		connection.close();
	} catch (UnknownHostException e) {
		parent.write("** Unknown Host exception in Server_Return_Info_Source.");
	} catch (EOFException oef) {
		parent.write("** Server terminated connection in Client_Register.");
	} catch (IOException e) {
		parent.write("** IO Exception in Client_Register.");
		e.printStackTrace();
	}
}
}
