/*
 * @(#)ClientAgentGUI.java
 * FileSharing package
 * MSE Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 */
package ksu.cis.example.FileSharing;
import java.awt.*;
import java.awt.event.*;

/**
 * GUI for Client agent. It has a text field to input the what file to request,
 * and from whom.
 * @author Chairoj Mekprasertvit
 *
 */
public class ClientAgentGUI extends Frame
{
  private TextField field;
  private TextArea display;
  private ClientAgent agent;
  
  /**
   * Constrcutor for agent_interface.
   * @param name
   * @param broadcastAddress
   */
  public ClientAgentGUI()
  {
    super("Please Wait...");
    setLayout (new BorderLayout());
    field = new TextField();
    display = new TextArea();
    add(display, "Center");
    display.setBackground(Color.white);
    display.setForeground(Color.black);
    add(field, "South");
   
    setSize(300, 200);
    setVisible(true);
    show();
    
    agent = new ClientAgent(this);
    Thread t = new Thread(agent);
    t.start();

    //create field for outgoing secured multicast message.
    field.setEnabled(false);
    field.addActionListener
    (
      new ActionListener() 
      {
        public void actionPerformed(ActionEvent e)
        {
          setDisplay(e.getActionCommand());
          agent.sendRequest(e.getActionCommand());
        }
      }
    );
  }
  
  public void startUI()
  {
    field.setEnabled(true);
    setTitle("Demo III: " + agent.name);
    setDisplay("** Client started.");
  }
  
  /**
   * <p>Enable the TextField. Allows user to type secured multicast message.
   */
  public void setField()
  {
    field.setEnabled(true);
  }
  
  public void setDisplay(String m)
  {
    display.append(m + "\n");
  }

  /**
   * main method
   * @param args
   */
  public static void main(String[] args)
  {
    ClientAgentGUI gui = new ClientAgentGUI();
    gui.addWindowListener
    (
      new WindowAdapter()
      {
        public void windowClosing(WindowEvent e)
        {
          System.exit(0);
        }
      }
    );
    gui.startUI();
  }// end of main method
}
