/*
 * @(#)ClientReceiveFile.java
 * FileSharing package
 * MSE Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 */
package ksu.cis.example.FileSharing;

import ksu.cis.mom.*;
import java.net.*;
import java.io.*;

/**
 * Unicast conversation respondent.
 * @author Chairoj Mekprasertvit
 *
 */
public class ClientReceiveFile extends Conversation
{
  private ClientAgent parent;
  private ClientAgentGUI gui;
  private File file;
  public ClientReceiveFile(
    Socket s,
    ObjectInputStream i,
    ObjectOutputStream o,
    ClientAgent a,
    Message m,
    ClientAgentGUI gui)
  {
    super(s, i, o, a, m);
    parent = a;
    this.gui = gui;
  }

  /**
   * 
   * @see java.lang.Runnable#run()
   */
  public void run()
  {
    int state = 0;
    boolean notDone = true;
    try
    {
      while(notDone)
      {
        switch(state)
        {
          case 0:
            InfoObject info = (InfoObject) m.content;
            try
            {
              FileOutputStream out = new FileOutputStream(info.getFileName());
              out.write(info.getFile());
              out.close();
            }
            catch(IOException ioex)
            {
              parent.write("** Error writing file." + ioex.toString());
            }
            state = 1;

          case 1:
            Message reply = new Message();
            reply.setPerformative("ack");
            sendMessage(reply, output);
            gui.setDisplay("** Agent successfully get the file");
            notDone = false;
            break;
        }
      }
      input.close();
      output.close();
      connection.close();
    }
    catch (UnknownHostException e)
    {
      parent.write("** Unknown Host exception in Client_Register.");
    }
    catch (EOFException oef)
    {
      parent.write("** Server terminated connection in Client_Register.");
    }
    catch (IOException e)
    {
      parent.write("** IO Exception in Client_Register.");
    }
  }// end run method
}// end class
