/*
 * @(#)ClientGetKey.java
 * agentMom package
 * MSE Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 */
package ksu.cis.example.KeyDistribution; 
import ksu.cis.mom.*;
import java.io.*;
import javax.net.ssl.*;

/**
 * @author Chairoj Mekprasertvit
 *
 */
public class ClientGetKey extends SecureUnicastConversation
{
  public ClientAgent parent;
  public ClientGetKey(
  SSLSocket s,
  ObjectInputStream i,
  ObjectOutputStream o,
  ClientAgent a,
  Message m)
  {
    super(s, i, o, a, m);
    parent = a;
  }
  
  /**
   * 
   * @see java.lang.Runnable#run()
   */
  public void run()
  {
    int state = 0;
    boolean notDone = true;
    try
    {
      while (notDone)
      {
        switch (state)
        {
          case 0 : 
            Message reply = new Message();
            reply.setPerformative("ack");
            sendMessage(reply, output);
            
            notDone = false;
            state = 1;
            break;
        }
      }
      input.close();
      output.close();
      connection.close();
    }
    catch (EOFException eof)
    {
      parent.write("** Server terminated connection in SSL.");
    }
    catch (IOException e)
    {
      parent.write("** IO Exception in SSL.");
    }
  }
}
