/*
 * Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 *
 */
package ksu.cis.example.KeyDistribution;

import ksu.cis.mom.*;
import java.net.*;
import java.io.*;
import java.util.*;

/**
 * @author Chairoj Mekprasertvit
 *
 */
public class ClientReturnRegister extends BroadcastConversation
{
  private ClientAgent parent;
  private ClientAgentGUI gui;
  private String conversation_name = "ClientReturnRegister";
  public ClientReturnRegister(
  DatagramSocket dSocket,
  Vector queue,
  ClientAgent a,
  int b_port,
  Message m,
  ClientAgentGUI gui)
{
  super(a, a.broadcast_address, b_port, queue, m);
  this.gui = gui;
  this.dSocket = dSocket;
  parent = a;
}

  /**
   * <p>Run method. Broadcast IP address of itself when received broadcast request
   * to register.
   * @see java.lang.Runnable#run()
   */
  public void run()
  {
    boolean notDone = true;
    InetAddress ip = null;
    int state = 0;
    int result = 0;

    while(notDone)
    {
      switch(state)
      {
        case 0:
        try
        {        
          ip = InetAddress.getLocalHost();
          System.out.println(ip.getHostAddress());
          state = 1;
        }
        catch(UnknownHostException e)
        {
          System.out.println("** Unknowhost Exception in ClientReturnRegister.");
        }
          break;
        case 1:
          Message register = new Message();
          register.setPerformative("register");
          register.setContent((Object)ip);
          try
          {
            sendMessage(register, conversation_name, "DistributorRequestRegister");
            gui.setDisplay("** Agent sends register IP: " + ip.getHostAddress());
            System.out.println("** Agent sends register IP: " + ip.toString());
          }
          catch (IOException ioex)
          {
            parent.write(ioex.toString());
          }
          notDone = false;          
          break;
      }// end switch
    }// end while
  }// end run method
}// end class
