/*
 * @(#)SecureMulticastSend.java
 * KeyDistribution package
 * MSE Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 */
package ksu.cis.example.KeyDistribution;

import java.net.*;
import java.io.*;
import java.security.*;
import ksu.cis.mom.*;
/**
 * @author Chairoj Mekprasertvit
 *
 */
public class SecureMulticastSend extends SecureMulticastConversation
{
  private ClientAgent parent;
  private ClientAgentGUI gui;
  private String mesg;
  private String conversation_name = "SecureMulticastSend";
  public SecureMulticastSend(
    ClientAgent a,
    int port,
    InetAddress group,
    String m,
    ClientAgentGUI gui,
    Key k,
    String algorithm)
    {
      super(a, group, port, a.secure_multicast_queue, k, algorithm);
      parent = a;
      this.gui = gui;
      this.mesg = m;
    }

  /**
   * 
   * @see java.lang.Runnable#run()
   */
  public void run()
  {
    Message m = new Message();
    int state = 0;
    boolean notDone = true;
    try
    {
      while(notDone)
      {
        switch(state)
        {
          case 0:
            m.performative = "display";
            m.content = this.mesg;
            startConversation(m, conversation_name, "SecureMulticastReceive");
            state = 1;
            break;
          case 1:
            notDone = false;
            break;
        }
      }
    }
    catch (IOException e)
    {
      parent.write("** IO Exception in secured multicast conversation.");
    }

  }

}
