package ksu.cis.momtest;

import java.io.*;
import java.net.*;
import ksu.cis.mom.*;
/**
 * This type was created in VisualAge.
 */
public class ClientAgent extends Agent
{
	AgentGUI gui;

	public String serverHost;
	public int serverPort;
/**
 * ClientAgent constructor comment.
 */
public ClientAgent(String agentName, int agentPort, 
	String sHost, int sPort)
{
	super(agentName, agentPort);

	gui = new AgentGUI(agentName);

	this.serverHost = sHost; // the Host to connect to
	this.serverPort = sPort; // the Port to connect to
	
	/* server initialization */

	MessageHandler h = new MessageHandler(this.port, this);
	h.start();

}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String get_service()
{
	if (this.name.equals("Client-1"))
		return "Laundry";
	if (this.name.equals("Client-2"))
		return "Dry Cleaning";
	if (this.name.equals("Client-3"))
		return "Drill Press Operator";
	else
		return "Unknown";
}
/**
 * This method was created in VisualAge.
 * @param args java.lang.String[]
 */
public static void main(String[] args)
{
	String serverHost;
	int serverPort = 5000;
	
	try
	{
		serverHost = InetAddress.getLocalHost().getHostName();
		ClientAgent s = new ClientAgent("Client", 3000, serverHost, serverPort);
		s.run();
	}
	catch (UnknownHostException e)
	{
		System.out.println(" ** Unknown Host Exception when starting ClientAgent");
	}
}
/**
 * receiveMessage method comment.
 */
public void receiveMessage(Socket server, ObjectInputStream input, ObjectOutputStream output)
{
	int i;
	Message m;
	Server_Register s;
	Thread t;

	/* define all possible conversations receivable here */

	try
	{
		m = (Message) input.readObject();
		System.out.println(" ** Invalid Attempt to start new conversation with performative " + m.performative + " from " + m.sender);
		t = new Thread(new Sorry(server, input, output, this, m));
		t.start(); // start new thread
	} catch (ClassNotFoundException cnfex)
	{
		System.out.println(" ** ClassNotFoundException ");
	} catch (IOException cnfex)
	{
		System.out.println(" ** IOException on port (ServerAgent.receiveMessage)");
	}
}
/**
 * This method was created in VisualAge.
 * @param args java.lang.String[]
 */
public void run()
{
	Thread init;
	write("Starting Client");
	//

	init = new Thread(new Client_Register(this, serverHost, serverPort, get_service())); // start conversation
	init.start();
	//

	int j;
	for (int i = 0; i < 10000000; i++)
		j = i - 1;
	//

	init = new Thread(new Client_Unregister(this, serverHost, serverPort, get_service())); // start conversation
	init.start();
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void write(String s)
{
	gui.write(s);
}
}
