package ksu.cis.momtest;

import java.util.*;
import java.net.*;
import java.io.*;
import ksu.cis.mom.*;

/**
 * This type was created in VisualAge.
 */
public class ServerAgent extends Agent
{
	AgentGUI gui = new AgentGUI("Server");

	private Vector registrants = new Vector(25);
/**
 * ServerAgent constructor comment.
 */
public ServerAgent(String n, int p)
{
	super(n, p);
	
	/* server initialization */

	MessageHandler handler;
	handler = new MessageHandler(port, this);
	handler.start();
}
/**
 * This method was created in VisualAge.
 * @param agent java.lang.String
 * @param service java.lang.String
 * @param host java.lang.String
 * @param port int
 */
protected void add_service(String agent, String service, String host, int port)
{
	this.registrants.addElement(new Registration(agent, host, port, service));
}
/**
 * This method was created in VisualAge.
 * @param args java.lang.String[]
 */
public static void main(String[] args)
{
	ServerAgent s = new ServerAgent("Server", 5000);
	s.run();
}
/**
 * This method was created in VisualAge.
 */
protected void printRegistrants()
{
	java.util.Enumeration enum = this.registrants.elements();
	Registration v;
	enum = this.registrants.elements();
	while (enum.hasMoreElements())
	{
		v = (Registration) enum.nextElement();
		write("< " + v.agent + ", " + v.service + ", " + v.host + ", " + v.port + ">");
	}
}
/**
 * receiveMessage method comment.
 */

public void receiveMessage(
  Socket server,
  ObjectInputStream input,
  ObjectOutputStream output)
{
  int i;
  Message m;
  Server_Register s;
  Thread t;

  /* define all possible conversations receivable here */

  try
  {
    m = (Message) input.readObject();
    write("Received message " + m.performative + " from " + m.sender);

    if (m.performative.equals("register"))
    {
      t = new Thread(new Server_Register(server, input, output, this, m));
      t.start(); // start new thread
    }
    else if (m.performative.equals("unregister"))
    {
      t = new Thread(new Server_Unregister(server, input, output, this, m));
      t.start(); // start new thread
    }
    else
    {
      System.out.println(
        " ** Invalid Attempt to start new conversation with performative "
          + m.performative
          + " from "
          + m.sender);
      t = new Thread(new Sorry(server, input, output, this, m));
      t.start(); // start new thread
    }
  }
  catch (ClassNotFoundException cnfex)
  {
    System.out.println(" ** ClassNotFoundException ");
  }
  catch (IOException cnfex)
  {
    System.out.println(" ** IOException on port (ServerAgent.receiveMessage)");
  }
}
/**
 * This method was created in VisualAge.
 * @param agent java.lang.String
 * @param service java.lang.String
 * @param host java.lang.String
 * @param port int
 */
protected void remove_service(String agent, String service, String host, int port)
{
	java.util.Enumeration enum = this.registrants.elements();
	Registration v;
	while (enum.hasMoreElements())
	{
		v = (Registration) enum.nextElement();
		if (v.agent.equals(agent) && v.service.equals(service) && v.host.equals(host) && v.port == port)
			this.registrants.removeElement(v);
	}
}
/**
 * This method was created in VisualAge.
 * @param args java.lang.String[]
 */
public void run()
{
	write("Starting Server");
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void write(String s)
{
	gui.write(s);
}
}
