/*
 * Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 *
 */
package ksu.cis.test;
import ksu.cis.mom.*;
import java.util.*;
import java.net.*;
import java.io.*;
import javax.net.ssl.*;
/**
 * @author Chairoj Mekprasertvit
 *
 */
public class agentServer extends Agent
{
  public static final int u_port = 3000;
  public static final int su_port = 3001;
  public static final int m_port[] = { 3002, 3003 };
  public static final int b_port = 3004;
  public static final int sm_port[] = { 3005, 3006 };
  public int type;
  public String command;
  public boolean alive;

  public agentServer()
  {
    super("agentServer", u_port, m_port, b_port, su_port, sm_port);
    alive = true;
    command = new String();

    try
    {
      super.group = new InetAddress[5];
      super.group[0] = InetAddress.getByName("239.255.10.11");
      super.broadcast_address = InetAddress.getByName("129.130.11.255");
    }
    catch (Throwable e)
    {
      write("Invalid Internet Address");
    }

    type = 0;
    MessageHandler h = new MessageHandler(u_port, this);
    h.start();
    MulticastHandler mh = new MulticastHandler(this, m_port[0], 1, group[0]);
    mh.start();
    BroadcastHandler bh =
      new BroadcastHandler(this, b_port, broadcast_address);
    bh.start();
    SecureUnicastHandler suh = new SecureUnicastHandler(su_port, this);
    suh.start();
  }

  public void receiveMessage(
    Socket server,
    ObjectInputStream input,
    ObjectOutputStream output)
  {
    Message m;
    Thread t;
    try
    {
      m = (Message) input.readObject();
      if (m.performative.equals("calculate"))
      {
        t = new Thread(new UnicastServer(server, input, output, this, m));
        t.start();
      }
      else
        alive = false;
    }
    catch (ClassNotFoundException cnfex)
    {
      write("** Error class not found");
    }
    catch (IOException ex)
    {
      write("** Error read unicast input");
    }
  }

  public void receiveSecureUnicastConversation(
    SSLSocket server,
    ObjectInputStream input,
    ObjectOutputStream output)
  {
    Message m;
    Thread t;
    try
    {
      m = (Message) input.readObject();
      
      if (m.performative.equals("calculate"))
      {
        this.write("** Start SecureUnicast");
        t = new Thread(new SecureUnicastServer(server, input, output, this, m));
        t.start();
      }
      else
        alive = false;
    }
    catch (ClassNotFoundException cnfex)
    {
      write("** Error class not found");
    }
    catch (IOException ex)
    {
      write("** Error read unicast input");
    }
  }

  public void receiveMulticastConversation(
    MulticastSocket mSocket,
    Message m,
    Vector multicast_queue)
  {
    Thread t;

    if (m.performative.equals("calculate"))
    {
      t = new Thread(new MulticastServer(mSocket, multicast_queue, this, m_port[0], m));
      t.start();
    }
    else
      alive = false;

  }

  public void receiveBroadcastConversation(
    DatagramSocket bSocket,
    Message m,
    Vector broadcast_queue)
  {
    Thread t;
    if (m.performative.equals("calculate"))
    {
      t = new Thread(new BroadcastServer(bSocket, broadcast_queue, this, b_port, m));
      t.start();
    }
    else
      alive = false;
  }

  public void run()
  {
    while (alive)
    {

    }
  }

  public static void main(String[] args)
  {
    agentServer as = new agentServer();
    as.run();
  }
}
