/*
 * Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 *
 */
package ksu.cis.test;
import ksu.cis.mom.*;
import java.util.*;
import java.net.*;
import java.io.*;
import javax.net.ssl.*;
import java.awt.*;

/**
 * test agent for demo
 * @author Chairoj Mekprasertvit
 *
 */
public class agent_test extends Agent 
{
  public static final int u_port = 3000;
  public static final int su_port = 3001;
  public static final int m_port[] = {3002, 3003};
  public static final int b_port = 3004;
  public static final int sm_port[] = {3005, 3006};
  public int type;
  public String command;
  public boolean alive;
  public TextArea display;
  
  
  public agent_test()
  {
    super("agent test", u_port, m_port, b_port, su_port, sm_port);
    alive = true;
    command = new String();
    try
    {
      super.group = new InetAddress[5];
      super.group[0] = InetAddress.getByName("239.255.10.11");
      super.broadcast_address = InetAddress.getByName("129.130.11.255");
    }
    catch(Throwable e)
    {
      write("Invalid Internet Address");
    }

    type = 0;
    MessageHandler h = new MessageHandler(u_port, this);
    h.start();
    MulticastHandler mh = new MulticastHandler(this, m_port[0], 1, group[0]);
    mh.start();
    BroadcastHandler bh = new BroadcastHandler(this, b_port, broadcast_address);
    bh.start();
    SecureUnicastHandler suh = new SecureUnicastHandler(su_port, this);
    suh.start();
    
  }
  
  public void receiveMessage(
    Socket server,
    ObjectInputStream input,
    ObjectOutputStream output)
  {
    this.write("start conversation IGNORE."); 
  }
  
  public void receiveSecureUnicastConversation(
    SSLSocket server,
    ObjectInputStream input,
    ObjectOutputStream output)
  {
    this.write("start conversation IGNORE."); 
  }
  
  public void receiveMulticastConversation(
    MulticastSocket mSocket,
    Message m,
    Vector multicast_queue)
  {
    this.write("start conversation IGNORE."); 
  }
  
  public void receiveBroadcastConversation(
    DatagramSocket bSocket,
    Message m,
    Vector broadcast_queue)
  {
    this.write("start conversation IGNORE."); 
  }
  
  public void setCommand(int type, String mesg, TextArea display)
  {
    this.command = mesg;
    this.type = type;
    this.display = display;
  }
    
  public void run()
  {
    int state = 0;
    Thread init = new Thread();
    while(alive)
    {
      state = this.type;
      StringTokenizer token = new StringTokenizer(command);
      switch(state)
      {
        case 0:
        try
        {
          this.write("Agent go to sleep");
          Thread.sleep(10000);
          state = type;
          this.write("Agent get up");
        }
        catch(InterruptedException e)
        {
          System.out.println(e.toString());
        }
        break;
        case 1:
          this.write("Initiate Conversation");
          init = new Thread(new unicast(
            this, token.nextToken(), u_port, token.nextToken(), display));
          init.start();
          state = 0;
          type = 0;
          break;
        case 2:
          this.write("Initiate Multicast Conversation");
          init = new Thread(new multicast(
            this, m_port[0], group[0], command, display));
          state = 0;
          type = 0;
          init.start();
          break;
        case 3:
          this.write("Initiate Broadcast Conversation");
          init = new Thread(new broadcast(
            this, b_port, broadcast_address, command, display));
          state = 0;
          type = 0;
          init.start();
          break;
        case 4:
          this.write("Initiate SecureUnicastConversation");          
          init = new Thread(new secureunicast(
            this, token.nextToken(), su_port, token.nextToken(), display));
            init.start();
          state = 0;
          type = 0;
          break;
        default:
          alive = false;
          state = 0;
          type = 0;
          break;
      }// end switch
    }// end while
  }// end run method
}// end class agent_test
